// Ejercicio #1: una BD
// Fecha: 16/11/2020; 5 pm
// S. Galliano

#include "menu.h"
#include "onat.h"
#include <iostream>
#include <fstream>
#include <cstdlib>

int main() {
    using std::cout;
    using std::cerr;
    using std::cin;
    Str info( "Ejercicio #1: una BD.\n\n" );
    Str archy( "C://temp//bd//taxes.txt" );
    Str nom;
    std::ofstream Escribe( archy );
    Onat *pImp = new Onat;
    short opcion;
    int n = 0;

    while ( true ) {
        opcion = menu( info );

        if ( Terminar == opcion ) {
            delete pImp;
            return EXIT_SUCCESS;
        } else
            n = pImp->getTam();

        switch ( opcion ) {
        case Insertar:
            pImp->entrar();
            break;
        case Mostrar:
            if ( 0 == n )
                cerr << ERR_V;
            else
                pImp->mostrar( cout );
            break;
        case Contar:
            0 == n
                ? cout << ERR_V
                : 1 == n
                    ? cout << "\nUn registro.\n\n"
                    : cout << '\n' << n << " registros.\n\n";
            break;
        case Escribir:
            if ( 0 == n )
                cerr << ERR_V;
            else {
                cout << "\nEscribiendo a " << archy << "...\n";
                pImp->mostrar( Escribe );
                cout << HECHO;
            } // if-else
            break;
        case Ver:
            if ( 0 == n )
                cerr << ERR_V;
            else {
                cout << "\nNombre: ";
                std::getline( cin, nom );

                if ( pImp->yaEsta( nom ) )
                    cout << ERR_Y;
                else
                    cout << ERR_N;
            } // if-else
            break;
        case Borrar:
            if ( 0 == n ) {
                cerr << ERR_V;
            } else {
                cout << "\nNombre: ";
                std::getline( cin, nom );
                if ( pImp->yaEsta(nom)) {
                    pImp->borrar( nom );
                } else {
                    cerr << ERR_N;
                } // if-else
            } // if-else
            break;
        case Vaciar:
            if ( 0 == n )
                cerr << ERR_V;
            else {
                char sn;
                cout << "Esta operacion vcia la BD Prosigo (s/n): ";
                cin >> sn;

                if ( 'S' == sn or 's' == sn ) {
                    pImp->vacia();
                    cout << HECHO;
                } else
                    cerr << "Abortando.\n\n";
            } // if-else
            break;
        default:
            std::cerr << "\nPor hacer...\n\n";
            break;
        } // switch

        system( "pause" );
    } // while
}
/*
En el Reino del Revs la unidad monetaria es el bitkoin (bK) y su ONAT
presenta el siguiente tipo de impuesto anual:

Los primeros 5,000 bK no pagan impuestos;
los siguientes 10,000 bK pagan el 10%;
los siguientes 20,000 bK pagan el 15%;
y entradas mayores de 35,000 bK pagan el 20% de impuestos.

Por ejemplo, si alguien declara 38,000 bitkoins de ganancia, deber pagar
por concepto de impuestos:
    5000 + 10000  0.1 + 20000  0.15 + 3000 0.2 = 4600 bK.

Se pide llevar una BD con los impuestos mensuales de una comunidad.
*/

