#ifndef ONAT_H_INCLUDED
#define ONAT_H_INCLUDED

// onat.h: ejercicio #1
// Fecha: 16/11/2020; 5 pm

#include <fstream>
#include <string>
typedef std::string Str;
const Str ERR_A( "\nNo pude abrir el archivo.\n\n" );
const Str ERR_V( "\nBase vac\241a.\n\n" );
const Str ERR_Y( "\nYa est\240.\n\n" );
const Str ERR_N( "\nNo est\240.\n\n" );
const Str HECHO( "\255Hecho!\n\n" );

class Entidad {
public:
    Entidad( Str nom = "", double gan = 0 ); // constructor
    // accesores
    void setNom( Str valor )    { nombre   = valor; }
    void setGan( double valor ) { ganancia = valor; }
    void setImp( double valor ) { impuesto = valor; }
    Str    getNom() const { return nombre;   }
    double getGan() const { return ganancia; }
    double getImp() const { return impuesto; }
    // mtodos
    void mostrar( std::ostream & os ) const;
    void calcImp();
private:
    Str nombre;
    double ganancia;
    double impuesto;
};

#include <list>
typedef std::list<Entidad> Item;

class Onat {
public:
    Onat(){ item.clear(); }
    int    getTam() const { return item.size(); }
    double getImp( Str nom ) const;
    void mostrar( std::ostream & os );
    void entrar();
    void borrar( Str nom );
    bool yaEsta( Str nom ) const;
    void vacia() { item.clear(); }
private:
    Item item;
};

// operador mayor-que: ordenamiento dbil
bool mayorQue( const Entidad & e1, const Entidad & e2 );

#endif // ONAT_H_INCLUDED
