//  nodo.cpp: bibliogafa
//  Fecha: 13/10/2020; 8:35 am
//  S. Galliano.
#include "nodo.h"

void Nodo::vaciar() { vct.clear(); }

bool Nodo::buscarA( Str nombre ) const {
    for ( auto x: vct )
        if ( nombre == x.first )
            return true;

    return false;
}

bool Nodo::buscarO( Str titulo ) const {
    for ( auto x: vct )
        if ( titulo == x.second )
            return true;

    return false;
}

bool menor( const Data & d1, const Data & d2 ) {
    if ( d1.first < d2.first) {
        return true;
    } else if ( d1.first == d2.first and d1.second < d2.second ) {
        return true;
    } else {
        return false;
    } // if-en-cascada
}
#include <algorithm>

void Nodo::ordenar() { sort( vct.begin(), vct.end(), menor ); }

#include <iostream>
#include <iomanip>
#include <ios>
using std::cout;
using std::cin;
using std::cerr;

void Nodo::mostrar() {
    ordenar();
    std::ios::fmtflags oldFlags = cout.flags();
    cout << std::left << std::setw( 20 ) << "Autor" << "T\241tulo\n" << std::right;

    for ( auto x: vct ) {
        cout <<
        std::left << std::setfill( '.' )       <<
        std::setw( 20 ) << x.first << x.second <<
        std::right << std::setfill( ' ' )      << '\n';
    } // for-en-rangos

    cout.flags( oldFlags );
}

void Nodo::insertar() {
    system( "cls" );
    cout << "Insertar unas obras. T para terminar.";
    Obra tmp;           // una estructura temporal
    Data dat;           // una data temporal
    Str nombre, titulo; // variables
    int n = 0;

    do {
        cout << "\nApellido, inicial del nombre del autor: ";
        getline( cin, nombre );

        if ( "" == nombre ) continue;
        else if ( 'T' == toupper( nombre[0] ) and 1 == nombre.size() ) break;
        else {
            cout << "T\241tulo de su obra: ";
            getline( cin, titulo );

            if ( tmp.autorEsta( nombre ) and tmp.obraEsta( titulo ) ) {
                cerr << ERR_E;
            } else {
                tmp.entrarObra( nombre, titulo );
                dat = tmp.getDT();
                vct.push_back( dat );
                ++n;
            } // if-else
        } // if-else
    } while ( true ); // do-while

    n == 0
        ? cout << "Nada entr\242.\n\n"
        : n == 1
           ? cout << "Entr\242 una obra.\n\n"
           : cout << "Entraron " << n << " obras.\n\n";

}

void Nodo::eliminarA( Str nombre ) {
    Vct::iterator i = vct.begin();

    for ( auto x : vct ) {
        if ( nombre == x.first ) {
            vct.erase( i );
            return;
        } // if

        ++i;
    } // for-en-rangos
}

void Nodo::eliminarO( Str titulo ) {
    Vct::iterator i = vct.begin();

    for ( auto x : vct ) {
        if ( titulo == x.second ) {
            vct.erase( i );
            cerr << HECHO;
            return;
        } // if

        ++i;
    } // for-en-rangos
}
