//  Ejercicio 6: CPA
//  Fecha: 24/10/2020; 7:40 am
//  S. Galliano

#include "menu.h"
#include "obrero.h"
#include "nomina.h"
#include <iostream>
#include <cstdlib>

int main() {
    using std::cout;
    using std::cerr;
    using std::cin;
    Str info( "Ejercicio 6: n\242mina de la CPA Santos Garc\241a.\n\n" );
    Nomina * pNomina = new Nomina;
    Obrero nodo;
    Datos dato;
    Str nom, ape;
    int hrs, cant, opcion;

    while ( true ) {
        opcion = menu( info );

        if ( Terminar == opcion ) {
            delete pNomina;
            return EXIT_SUCCESS;
        } else
            cant = pNomina->contar();

        switch ( opcion ) {
        case Insertar:
            cout << "Nombre: ";
            std::getline( cin, nom );
            cout << "Apellido: ";
            std::getline( cin, ape );
            cout << "Horas: ";
            (cin >> hrs).get();
            dato = std::make_tuple( nom, ape, hrs );
            nodo.setDato( dato );
            if ( pNomina->yaEsta( nodo ) )
                cerr << MSG_Y;
            else {
                pNomina->entrar( nodo );
                cout << HECHO;
            }
            break;
        case Contar:
            if ( 0 == cant )
                cerr << MSG_V;
            else
                1 == cant
                    ? cout << "Hay un record.\n\n"
                    : cout << "Hay " << cant << " records.\n\n";
            break;

        case Checar:
            cout << "Nombre: ";
            std::getline( cin, nom );
            cout << "Apellido: ";
            std::getline( cin, ape );
            dato = std::make_tuple( nom, ape, 0 );
            nodo.setDato( dato );

            if ( pNomina->yaEsta( nodo ) )
                cout << MSG_Y;
            else
                cout << MSG_N;
            break;

        case Borrar:
            if ( 0 == cant ) {
                cerr << MSG_V;
            } else {
                cout << "Nombre: ";
                std::getline( cin, nom );
                cout << "Apellido: ";
                std::getline( cin, ape );
                dato = std::make_tuple( nom, ape, 0 );
                nodo.setDato( dato );

                 if ( pNomina->yaEsta( nodo ) ) {
                     pNomina->borrar( nodo );
                     cout << HECHO;
                 } else {
                     cerr << MSG_N;
                 } // if-else
            } // if-else

        case Cargar:
            try {
                pNomina->subir();
                cout << HECHO;
            } catch( Str ) {
                cerr << ERR_A;
            }
            break;
        case Vaciar:
            cout << "Operaci\242n sin retorno \250Prosigo (s/n)? ";
            char sn;
            (cin >> sn).get();

            if ( 'S' == sn or 's' == sn ) {
                pNomina->vaciar();
                cout << HECHO;
            } else
                cerr << "Operaci\242n abortada.\n\n";
            break;

        case Editar:
            if ( 0 == cant ) {
               cerr << MSG_V;
            } else {
                cout << "Nombre: ";
                std::getline( cin, nom );
                cout << "Apellido: ";
                std::getline( cin, ape );
                dato = std::make_tuple( nom, ape, 0 );
                nodo.setDato( dato );

                if ( pNomina->yaEsta( nodo ) )
                    pNomina->editar( nodo );
                else
                    cout << MSG_N;
            } // if-else
            break;

        case Crear:
            pNomina->escribir( cout );
            break;

        default:
            cerr << "Por hacer.\n\n";
            break;
        } // switch

        system( "pause" );
    } // while
}
