// nomina.cpp: ejercicio 6
// Fecha: 24/10/2020; 7:40 am
#include "nomina.h"

// funcin de ordenamiento fuerte, de menor a mayor
bool menor( Obrero &nodo1, Obrero &nodo2 ) {
    Str obrero1 = nodo1.mostrarInfo();
    Str obrero2 = nodo2.mostrarInfo();

    if ( obrero1 < obrero2 )
        return true;
    else
        return false;
}

bool Nomina::estaVacia() const { return vct.size() == 0; }
int  Nomina::contar() const { return vct.size(); }
void Nomina::vaciar() { vct.clear(); }

#include <algorithm>

void Nomina::entrar( Obrero &nodo ){
    vct.push_back( nodo );
    sort( vct.begin(), vct.end(), menor );
}

bool Nomina::yaEsta( Obrero &nodo ) const {
    Datos dato = nodo.getDato();
    Str n, nom = std::get<0>( dato );
    Str a, ape = std::get<1>( dato );
    int h;

    for ( auto x: vct ) {
        std::tie( n, a, h ) = x.getDato();

        if ( nom == n and ape == a)
            return true;
    }

    return false;
}

// asume que el registro ya est
void Nomina::borrar( Obrero &nodo ){
    Datos d, dato = nodo.getDato();
    Str n, nom, a, ape;
    int h, hrs;
    std::tie( nom, ape, hrs ) = dato;
    Vct::iterator i = vct.begin();

    for ( auto x: vct ) {
        d = x.getDato();
        std::tie( n, a, h ) = d;

        if ( nom == n and ape == a)
            vct.erase( i );
        else
            ++i;
    }
}

#include<iostream>
using std::cin;
using std::cout;
using std::getline;

// asume que el registro ya est
void Nomina::editar( Obrero &nodo ) {
    Obrero n1, n2;
    Datos d, d1, d2;
    Str n, nom, a, ape;
    nodo.getDato();

    d1 = std::make_tuple( nom, ape, 0 );
    n1.setDato( d1 );

    if ( not yaEsta( n1 ) ) {
        std::cerr << MSG_N;
        return;
    }

    int h, hrs;
    cout << "\250Nuevas horas? ";
    ( cin >> hrs ).get();

    d2 = std::make_tuple( nom, ape, hrs );
    n2.setDato( d2 );
    Vct::iterator i = vct.begin();

    for ( auto x: vct ) {
        d = x.getDato();
        std::tie( n, a, h ) = d;

        if ( nom == n and ape == a) {
            vct.erase( i );
            vct.push_back( n2 );
            return;
        } else
            ++i;
    }
}

#include <fstream>

void Nomina::subir(){
    std::ifstream Lee( "C:/temp/BD/plantilla.txt" );

    if ( Lee.fail() )
        throw ERR_A;

    Str nom, ape, hrs;
    Obrero nodo;

    while ( Lee.good() ) {
        getline( Lee, nom, ',' );
        getline( Lee, ape, ',' );
        getline( Lee, hrs );
        auto dato = std::make_tuple( nom, ape, atoi( hrs.c_str() ) );
        nodo.setDato( dato );

        if ( yaEsta( nodo ) )
            continue;
        else
            entrar( nodo );
    } // while
}

const int HORAS = 40; // a la semana
const int SEMANAS = 4; // 4 semanas por mes
const int PAGO = 500; // pesos
const double BASICO = static_cast<double>( PAGO ) / HORAS;
const double EXTRA = 1.5 * BASICO;

// funcin auxiliar: devuelve el salario devengado
double calcSalario( int hs ) {
    double salario;

    if ( hs > HORAS * SEMANAS ) {
        salario = ( hs - HORAS * SEMANAS ) * EXTRA;
        salario += HORAS * SEMANAS * BASICO;
    } else {
        salario = hs * BASICO;
    } // if-else

    return salario;
}

#include <ctime>
#include <iomanip>
#include <ios>


//  escribe la nmina a un flujo de salida;
//  llama a cada obrero de la nmina
void Nomina::escribir( std::ostream & Escribiendo ) {
    if ( Escribiendo.fail() )
        throw ERR_A;

    using std::setiosflags;
    using std::ios;
    using std::setw;
    sort( vct.begin(), vct.end(), menor );
    time_t laFecha = time( nullptr ); // obteniendo la fecha completa
    Str fecha = ctime( &laFecha );    // la fecha y la hora
    ios::fmtflags oldFlags = cout.flags();
    cout << setiosflags(ios::fixed | ios::showpoint) << std::setprecision(2);

    //  encabezado de la tabla
    system( "cls" );
    Escribiendo <<
    "CPA S. Garc\241a - N\242mina" << '\n' <<
    "Fecha: " << fecha << '\n' <<
    std::left << setw( 18 ) << "Obrero"  <<
    std::right << setw( 7 ) << "Horas" <<
    setw ( 18 ) << "Salario\n";

    //  cuerpo de la tabla
    Obrero nodo;
    Str obr;
    int hrs;
    double salario, total = 0; // total nmina
    Vct::const_iterator i;
    Vct::const_iterator end( vct.end() );
    Escribiendo << std::setfill( '.' );

    for ( i = vct.begin(); i != end; ++i ) {
        nodo = *i;
        obr = nodo.mostrarInfo();
        hrs = nodo.getHrs();
        salario = calcSalario( hrs );
        total += salario;
        Escribiendo <<
        std::left   << setw( 18 ) << obr <<
        std::right  << setw( 7 )  << hrs <<
        setw ( 17 ) << salario    << "  ____________\n";
    } // for

    // pie de la tabla
    Escribiendo <<
    std::left   << setw( 32 ) << "Total" <<
    std::right  << setw( 10 ) << total   << "$ Firma\n\n" <<
    std::setfill( ' ' );
    cout.flags( oldFlags );
}

