// estads.cpp: declaraciones del problema 7
// Fecha: 14/10/2020; 9:35 pm
// S. Galliano.
#include "estads.h"
#include <algorithm>

Estads::Estads( vInt vct ): v( vct) {
    n = v.size();
    sort( v.begin(), v.end() );
};

int Estads::cuenta() const { return n; }
int Estads::suma()   const { return accumulate( v.begin(), v.end(), 0.0 ); }

int Estads::SDC() const {
    std::vector<int>aux( v );
    transform( aux.begin(), aux.end(), aux.begin(), aux.begin(),
               std::multiplies<int>() );
    return accumulate( aux.begin(), aux.end(), 0 ); // suma de cuadrados
}

double Estads::media() const { return static_cast<double>( suma() ) / n; }
double Estads::varza() const {
    return static_cast<double>( ( SDC() ) - suma() * suma() / n ) / ( n - 1 );
}

double Estads::mediana() const {
    double resp;
    int idx = 0.5 * n;
    n % 2 ? resp = v[idx] : resp = 0.5 * ( v[idx - 1] + v[idx] );
    return resp;
}

int Estads::moda() const {
    int laModa, unaModa;
    int laRacha, unaRacha;
    laModa = unaModa = v[0];
    laRacha = unaRacha = 0;
    int i = 0;

    do {
        if ( unaModa not_eq v[i] ) {
            unaModa = v[i];

            if ( unaRacha > laRacha ) {
                laRacha = unaRacha;
                laModa  = v[i - 1];
            }

            unaRacha = 0;
        }

        ++unaRacha;
        ++i;
    } while ( i not_eq n );

    if ( 1 == laRacha )
        laModa = HUGE_VAL;

    return laModa;
}

int Estads::Min() const {
    return *min_element( v.begin(), v.end() );
}

int Estads::Max() const {
    return *max_element( v.begin(), v.end() );
}
