#ifndef ESTADS_H_INCLUDED
#define ESTADS_H_INCLUDED

// estads.h: declaraciones del problema 8
// Fecha: 15/10/2020; 10 am
// S. Galliano.

#include <vector>
#include <list>
#include <deque>
#include <functional>
#include <cmath>
#include <iostream>

template <typename T> class Estads {
public:
    Estads(): n_( 0 ) { v. clear(); }
    Estads( std::vector<T> vct ) {
        v.assign( vct.begin(), vct.end() );
        n_ = v.size();
        sort( v.begin(), v.end() );
    }
    Estads( std::list<T> & lst ) {
        v.assign( lst.begin(), lst.end() );
        n_ = v.size();
        sort( v.begin(), v.end() );
    }
    Estads( std::deque<T> & dek ) {
        v.assign( dek.begin(), dek.end() );
        n_ = v.size();
        sort( v.begin(), v.end() );
    }
    void operator()( T x ) {}
    int cuenta() const { return n_; }
    T suma() const {
        return accumulate( v.begin(), v.end(), 0.0 );
    }
    T SDC() const {
        std::vector<T>aux( v );
        transform( aux.begin(), aux.end(), aux.begin(), aux.begin(), std::multiplies<T>() );
        return accumulate( aux.begin(), aux.end(), 0 );
    }
    T Min() const { return *min_element( v.begin(), v.end() ); }
    T Max() const { return *max_element( v.begin(), v.end() ); }
    T moda() const {
        T laModa, unaModa;
        int laRacha, unaRacha, i = 0;
        laModa = unaModa = v[0];
        laRacha = unaRacha = 0;

        do {
            if ( unaModa not_eq v[i] ) {
                unaModa = v[i];

                if ( unaRacha > laRacha ) {
                    laRacha = unaRacha;
                    laModa  = v[i - 1];
                }

                unaRacha = 0;
            }

            ++unaRacha;
            ++i;
        } while ( i not_eq n_ );

        if ( 1 == laRacha )
            laModa = INFINITY;

        return laModa;
    }
    double mediana() const {
        double resp;
        int idx = 0.5 * n_;
        n_ % 2 ? resp = v[idx] : resp = 0.5 * ( v[idx - 1] + v[idx] );
        return resp;
    }
    double media() const { return static_cast<double>(suma()) / n_; }
    double varza() const { return static_cast<double>(SDC() - suma()*suma()/n_) / ( n_-1); }
private:
    int n_;
    std::vector<T> v;
};


#endif // ESTADS_H_INCLUDED
