// notas.cpp: definiciones para el ejercicio 10
// Fecha: 27/10/2020; 10:33 am
#include "notas.h"
#include <iostream>
#include <fstream>
#include <iomanip>

void Notas::ponerLinea( char ch ) {
    int ancho = 8 * ( vMats.size() + 1 ); // el ancho por columna
    std::cout << std::setfill( ch ) << std::setw( ancho ) << '\n' << std::setfill( ' ' );
}

void Notas::cargarMats( Str archy ){
    std::ifstream Leyendo( archy );
    if( not Leyendo.is_open() )
        throw ERR;

    Str recd;
    char delim = ',';
    int i = 0;
    vMats.clear();

    while( Leyendo.good() ) {
        std::getline( Leyendo, recd, delim );
        vMats.push_back( recd );
        ++i;
    } // while

    setC( vMats.size() );
}

void Notas::cargarNots( Str archy ) {
    std::ifstream Leyendo( archy );
    if( not Leyendo.is_open() )
        throw ERR;

    // recalibrar el arreglo
    vNots.resize( fil*col );

    // meter los datos
    Str recd;
    char delim = ',';
    int i = 0;

    while( Leyendo.good() ) {
        std::getline( Leyendo, recd, delim );
        vNots[i] = ( atof( recd.c_str() ) );
        ++i;
    }
}

#include <valarray>
#include "../../Programas/deposito/varray.h"

void Notas::calcular() {
    for( int i = 0; i < col - 1; ++i )
        vNots[std::slice( col - 1, fil, col )] +=
            VA( vNots[std::slice( i, fil, col )] ) / static_cast<double>( col - 1 );
}

#include "../../Programas/deposito/print.h"

//  pone la tabla en consola
void Notas::tabular() {
    // encabezado
    std::cout << "\nTabla de resultados\n";
    ponerLinea( '=' );
    MUESTRA( vMats, "Asig." ); std::cout << '\n';
    ponerLinea( '-' );
    std::cout << std::setprecision( 1 ) << std::fixed;

    // cuerpo
    PRINTVA( vNots, col, "Al. " ); // los promedios por alumno

    if( fil > 1 ) {    // particularizando a ms de un alumno
        Vad vp( col ); // los promedios de las notas

        for( int i = 0; i < col; ++i ) {
            for( int j = 0; j < fil; j++ )
                vp[i] += vNots[i + j * col];

            vp[i] /= fil;
        }

        ponerLinea( '-' );
        std::cout << "Prom.";
        PRINTVA( vp, col - 1 );
    }

    // pie
    std::cout << '\n';
    ponerLinea( '=' );
}
