#ifndef CRONO_H_INCLUDED
#define CRONO_H_INCLUDED

//  crono.cpp: definiciones para el problema 3
//  Fecha: 13/10/2019; 8:07 am
//  Revisin: 15/9/2020; 8:26 am
//  versin sobre Halterman, 16.2-STOPWATCH, pg. 477

#include <ctime>

/**
    @brief Crono: un crongrafo. Galliano, 2020.
*/
class Crono {
public:
    Crono() : comienzo( 0 ), contando( false ), transcurrido( 0 ) {}
    void start() {
        if ( not contando ) {
            contando = true;
            comienzo = clock();
        } // if
    }
    void stop() {
        if ( contando ) {
            contando = false;
            clock_t fin = clock();
            transcurrido += static_cast<double>( fin - comienzo ) / CLOCKS_PER_SEC;
        } // if
    }
    void reset() {
        contando = false;
        transcurrido = 0;
    }
    bool estaContando() const { return contando; }
        double reportar() {
        double resp;

        if ( contando ) {
            clock_t actual = clock();
            resp = static_cast<double>( actual - comienzo ) / CLOCKS_PER_SEC;
            resp += transcurrido;
            // si estaba parado, el tiempo ya est marcado en stop()
        } else {
            resp = transcurrido;
        } // if-else

        return resp;
    }
private:
    time_t comienzo;
    bool contando;
    double transcurrido;
};

#endif // CRONO_H_INCLUDED
