//  producto.cpp: definiciones para el programa 1
//  Fecha: 29/6/2020; 8:32 am
//  Revisin: 15/9/2020; 2:15 pm
//  Por: S. Galliano.

#include <iomanip>
#include <ios>
#include "producto.h"

using std::ios;

namespace misNombres {

Producto::Producto( Str nb, float co, float ve, int ct )
    : nombre( nb ), costo( co ), venta( ve ), cantidad( ct ) {}

// accesores de entrada:
void Producto::setNombre( Str valor )   { nombre   = valor; }
void Producto::setCantidad( int valor ) { cantidad = valor; }

// accesores de salida:
Str   Producto::getNombre()   const { return nombre;   }
float Producto::getCosto()    const { return costo;    }
float Producto::getVenta()    const { return venta;    }
int   Producto::getCantidad() const { return cantidad; }

// miembro
void Producto::muestra( std::ostream & escribe ) const {
    escribe << setiosflags( std::ios::fixed | std::ios::showpoint )
            << std::setprecision( 2 )
            << "\nNombre: "    << getNombre()
            << "\nCosto = $"   << getCosto()
            << "\nCantidad = " << getCantidad()
            << "\nA pagar: $"  << getCosto() * getCantidad() << "\n";
}

} // misNombres
