//  Programa 3: crongrafo
//  Fecha: 2/7/2020; 2:15 pm
//  Revisin: 15/9/2020; 8:26 am
//  S. Galliano.


#include "../deposito/crono.h"
#include "../deposito/rnd.h"
#include <iostream>
#include <cstdlib>
#include <list>
#include <vector>
#include <iomanip>

const int N = 500000;
const int PASE = 5;

typedef std::list<int>     lInt;
typedef std::vector<int>   vInt;

// funcin de comparacin de enteros
// input: dos vectores void
// output: 1 si *m > *n; -1 si *m < *n; 0 si *m == *n
inline int compInt( const void * m, const void * n ) {
    int p = *static_cast<const int *>( m );
    int q = *static_cast<const int *>( n );
    return p - q;
}

int main() {
    int m = 1, M = N * 0.5; //  lmites de los nmeros generados

    std::cout <<
    "Programa 3: Cronometrando.\n\n"
    "Comparaci\242n las formas de ordenamiento de qsort(),"
    "\nvector y lista, haciendo " << PASE << " pases sobre " << N <<
    "\nenteros, entre " << m << " y " << M <<  ", generados al azar.\n\n"
    "Tenga un poco de paciencia. Trabajando...\n\n";

    // variables
    vInt vct( N );           // un vector
    lInt lst;                // una lista
    int * pAry = new int[N]; // un arreglo en la tienda libre

    // las marcas del tiempo y los totales
    Crono tiempo, tiempo_t;
    double t_vct = 0, t_lst = 0, t_qck = 0, t_relleno = 0, t_total = 0;
    srand( time( nullptr ) );

    tiempo_t.start();

    for ( int i = 0; i < PASE; ++i ) {
        std::cout << "Pase #" << i + 1 << '\r';

        // el tiempo de llenar nuevos valores
        tiempo.start();
        RELLENA_I( vct, m, M );
        lst.assign( vct.begin(), vct.end() );
        copy( vct.begin(), vct.end(), pAry );
        tiempo.stop();
        t_relleno += tiempo.reportar();
        tiempo.reset();

        // el tiempo de sort() sobre el vector
        tiempo.start();
        std::sort( vct.begin(), vct.end() );
        tiempo.stop();
        t_vct += tiempo.reportar();
        tiempo.reset();

        // el tiempo de la lista
        tiempo.start();
        lst.sort();
        tiempo.stop();
        t_lst += tiempo.reportar();
        tiempo.reset();

        // el tiempo del qsort()
        tiempo.start();
        qsort( pAry, N, sizeof( int ), compInt );
        tiempo.stop();
        t_qck += tiempo.reportar();
        tiempo.reset();
    } // for

    tiempo_t.stop();
    t_total = tiempo_t.reportar();

    std::cout << std::fixed << std::setprecision( 4 ) <<
    "\n\nTiempo total consumido: " << t_total << " s" <<
    "\nTiempo promedio consumido por:\n"
    "    Llenado: " << t_relleno / PASE << " s/pase.\n"
    "  Quicksort: " << t_qck / PASE     << " s/pase.\n"
    "  El vector: " << t_vct / PASE     << " s/pase.\n"
    "  La lista:  " << t_lst / PASE     << " s/pase.\n\n";

    system( "pause" );
    return EXIT_SUCCESS;
}
