#ifndef ESTADS_H_INCLUDED
#define ESTADS_H_INCLUDED

// Programa 8: una plantilla functor
// Fecha: 1/10/2020; 1:50 pm
// Revisin: 3/10/2020; 5 pm

#include <vector>
#include <list>
#include <deque>
#include <algorithm>

template <typename T> class Estads {
public:
    Estads( std::vector<T> & vct ) {
        v.assign( vct.begin(), vct.end() );
        sort( v.begin(), v.end() );
    }
    Estads( std::list<T> & lst ) {
        v.assign( lst.begin(), lst.end() );
        sort( v.begin(), v.end() );
    }
    Estads( std::deque<T> & dek ) {
        v.assign( dek.begin(), dek.end() );
        sort( v.begin(), v.end() );
    }
    // al sobrecargar al operador () la plantilla es un functor
    void operator()( T & x ) {}
    // estos estadgrafos dependen del tipo dado
    T suma() const { return accumulate( v.begin(), v.end(), 0.0 ); }
    T SDC() const;
    // este estadgrafo siempre es entero
    int cuent() { return v.size(); }
    // estos estadgrafos siempre son dobles
    double media() const;
    double varza() const;
    double medin() const;
private:
    std::vector<T> v;
};

template<typename T> T Estads<T>::SDC() const {
    std::vector<T>aux( v );
    transform( aux.begin(), aux.end(), aux.begin(), aux.begin(), std::multiplies<T>() );
    return accumulate( aux.begin(), aux.end(), 0.0 );
}

template<typename T> double Estads<T>::media() const {
    return static_cast<double>( suma() ) / v.size();
}

template<typename T> double Estads<T>::varza() const {
    int n = v.size();
    return static_cast<double>( SDC() - suma() * suma() / n ) / ( n - 1 );
}

template<typename T> double Estads<T>::medin() const {
    int idx = 0.5 * v.size();
    double md = v[idx];

    if ( 0 == v.size() % 2 )
        md = 0.5 * ( v[idx - 1] + md );

    return md;
}

#endif // ESTADS_H_INCLUDED
